diff -uNrp ../vanilla/linux-2.6.19/kernel/exit.c 2.6.19-ppc-1.5-02/kernel/exit.c
--- ../vanilla/linux-2.6.19/kernel/exit.c	2006-11-29 22:57:37.000000000 +0100
+++ 2.6.19-ppc-1.5-02/kernel/exit.c	2007-06-11 17:15:48.000000000 +0200
@@ -914,6 +914,7 @@ fastcall NORET_TYPE void do_exit(long co
 	taskstats_exit_send(tsk, tidstats, group_dead, mycpu);
 	taskstats_exit_free(tidstats);
 
+	ipipe_exit_notify(tsk);
 	exit_mm(tsk);
 
 	if (group_dead)
diff -uNrp ../vanilla/linux-2.6.19/kernel/fork.c 2.6.19-ppc-1.5-02/kernel/fork.c
--- ../vanilla/linux-2.6.19/kernel/fork.c	2006-11-29 22:57:37.000000000 +0100
+++ 2.6.19-ppc-1.5-02/kernel/fork.c	2007-06-11 17:15:48.000000000 +0200
@@ -384,6 +384,7 @@ void mmput(struct mm_struct *mm)
 	might_sleep();
 
 	if (atomic_dec_and_test(&mm->mm_users)) {
+		ipipe_cleanup_notify(mm);
 		exit_aio(mm);
 		exit_mmap(mm);
 		if (!list_empty(&mm->mmlist)) {
@@ -914,7 +915,7 @@ static inline void copy_flags(unsigned l
 {
 	unsigned long new_flags = p->flags;
 
-	new_flags &= ~(PF_SUPERPRIV | PF_NOFREEZE);
+	new_flags &= ~(PF_SUPERPRIV | PF_NOFREEZE | PF_EVNOTIFY);
 	new_flags |= PF_FORKNOEXEC;
 	if (!(clone_flags & CLONE_PTRACE))
 		p->ptrace = 0;
@@ -1258,6 +1259,15 @@ static struct task_struct *copy_process(
 	spin_unlock(&current->sighand->siglock);
 	write_unlock_irq(&tasklist_lock);
 	proc_fork_connector(p);
+#ifdef CONFIG_IPIPE
+	{
+		int k;
+		
+		for (k = 0; k < IPIPE_ROOT_NPTDKEYS; k++)
+			p->ptd[k] = NULL;
+	}
+#endif /* CONFIG_IPIPE */
+ 
 	return p;
 
 bad_fork_cleanup_namespaces:
diff -uNrp ../vanilla/linux-2.6.19/kernel/ipipe/Kconfig 2.6.19-ppc-1.5-02/kernel/ipipe/Kconfig
--- ../vanilla/linux-2.6.19/kernel/ipipe/Kconfig	1970-01-01 01:00:00.000000000 +0100
+++ 2.6.19-ppc-1.5-02/kernel/ipipe/Kconfig	2007-06-11 17:15:48.000000000 +0200
@@ -0,0 +1,6 @@
+config IPIPE
+	bool "Interrupt pipeline"
+	default y
+	---help---
+	  Activate this option if you want the interrupt pipeline to be
+	  compiled in.
diff -uNrp ../vanilla/linux-2.6.19/kernel/ipipe/Kconfig.debug 2.6.19-ppc-1.5-02/kernel/ipipe/Kconfig.debug
--- ../vanilla/linux-2.6.19/kernel/ipipe/Kconfig.debug	1970-01-01 01:00:00.000000000 +0100
+++ 2.6.19-ppc-1.5-02/kernel/ipipe/Kconfig.debug	2007-06-11 17:15:48.000000000 +0200
@@ -0,0 +1,69 @@
+config IPIPE_DEBUG
+	bool "I-pipe debugging"
+	depends on IPIPE
+
+config IPIPE_TRACE
+	bool "Latency tracing"
+	depends on IPIPE_DEBUG
+	select FRAME_POINTER
+	select KALLSYMS
+	select PROC_FS
+	---help---
+	  Activate this option if you want to use per-function tracing of
+	  the kernel. The tracer will collect data via instrumentation
+	  features like the one below or with the help of explicite calls
+	  of ipipe_trace_xxx(). See include/linux/ipipe_trace.h for the
+	  in-kernel tracing API. The collected data and runtime control
+	  is available via /proc/ipipe/trace/*.
+
+config IPIPE_TRACE_ENABLE
+	bool "Enable tracing on boot"
+	depends on IPIPE_TRACE
+	default y
+	---help---
+	  Disable this option if you want to arm the tracer after booting
+	  manually ("echo 1 > /proc/ipipe/tracer/enable"). This can reduce
+	  boot time on slow embedded devices due to the tracer overhead.
+
+config IPIPE_TRACE_MCOUNT
+	bool "Instrument function entries"
+	depends on IPIPE_TRACE
+	default y
+	---help---
+	  When enabled, records every kernel function entry in the tracer
+	  log. While this slows down the system noticeably, it provides
+	  the highest level of information about the flow of events.
+	  However, it can be switch off in order to record only explicit
+	  I-pipe trace points.
+
+config IPIPE_TRACE_IRQSOFF
+	bool "Trace IRQs-off times"
+	depends on IPIPE_TRACE
+	default y
+	---help---
+	  Activate this option if I-pipe shall trace the longest path
+	  with hard-IRQs switched off.
+
+config IPIPE_TRACE_SHIFT
+	int "Depth of trace log (14 => 16Kpoints, 15 => 32Kpoints)"
+	range 10 18
+	default 14
+	depends on IPIPE_TRACE
+	---help---
+	  The number of trace points to hold tracing data for each
+	  trace path, as a power of 2.
+
+config IPIPE_TRACE_VMALLOC
+	bool "Use vmalloc'ed trace buffer"
+	depends on IPIPE_TRACE
+	---help---
+	  Instead of reserving static kernel data, the required buffer
+	  is allocated via vmalloc during boot-up when this option is
+	  enabled. This can help to start systems that are low on memory,
+	  but it slightly degrades overall performance. Try this option
+	  when a traced kernel hangs unexpectedly at boot time.
+
+config IPIPE_TRACE_ENABLE_VALUE
+	int
+	default 0 if !IPIPE_TRACE_ENABLE
+	default 1 if IPIPE_TRACE_ENABLE
diff -uNrp ../vanilla/linux-2.6.19/kernel/ipipe/Makefile 2.6.19-ppc-1.5-02/kernel/ipipe/Makefile
--- ../vanilla/linux-2.6.19/kernel/ipipe/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ 2.6.19-ppc-1.5-02/kernel/ipipe/Makefile	2007-06-11 17:15:48.000000000 +0200
@@ -0,0 +1,3 @@
+
+obj-$(CONFIG_IPIPE)	+= core.o generic.o
+obj-$(CONFIG_IPIPE_TRACE) += tracer.o
